// Demo2.h : Haupt-Header-Datei fr die Anwendung DEMO2
//

#if !defined(AFX_DEMO2_H__0CCBEE9A_A05F_4939_A79C_7677AA680A6D__INCLUDED_)
#define AFX_DEMO2_H__0CCBEE9A_A05F_4939_A79C_7677AA680A6D__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"		// Hauptsymbole

#define WM_THREAD        (WM_USER + 5)

// Defines fuer ausfuehrbare Aktionen (TA = ThreadAction)
#define TA_EinfachAusfuehren        0
#define TA_ImDialog                 1

// Messages von Thread an Dialog
#define MSG_PROGRESS         0 // Progressbar weiterzaehlen
#define MSG_COMMAND_START    1 // Eine Kommandoausfuehrung starten (bsp. Setup bertragen)
#define MSG_COMMAND_STOP     2 // Eine Kommandoausfuehrung beenden
#define MSG_INFORMATION      3 // Nachrichtentext als Information
#define MSG_EXCLAMATION      4 // Nachrichtentext als Feststellung
#define MSG_STOP             5 // Nachrichtentext als Fehler
#define MSG_QUESTION         6 // Frage
#define MSG_ERROR            7 // Fehler melden

//Vorbereitung BestFinger

#define FINGER_MAX           10    // Maximale Anzahl der Finger fr die Testreihe
#define SCANN_MAX            10    // Maximal Anzahl der Scanns pro Finger
#define TEMPLATE_FORMAT       2    // 0 DIN (161Byte), 1 Compact (216Byte), 2 Standard (560Byte)

#if (TEMPLATE_FORMAT == 2)
#define MINUTIAE_MAX        (50*11) // Standardformat Idencom
#define TEMPLATE_SIZE        560   // max. Gre eines Templates
#elif (TEMPLATE_FORMAT == 1)
#define MINUTIAE_MAX        (41*5) // Compact
#define TEMPLATE_SIZE        216   // max. Gre eines Templates
#else
#define MINUTIAE_MAX        (50*3) // DIN
#define TEMPLATE_SIZE        161   // max. Gre eines Templates
#endif

//Typendefinition fr bernommene Funktionen aus anderen Projekten
typedef unsigned char UINT8 ;
typedef unsigned short UINT16 ;

//Struktur eines Templates
typedef struct struct_template 
{

  UINT64 PID;                // 8 Bit fr die Personen Identifikationsnummer
  UINT8  FID;                // 1 Bit fr die Finger Identifikationsnummer
  UINT8  Quality;            // 1 Bit fr die Qualitt des Templates von 0..99
  UINT8  MinutiaeCount;      // 1 Bit Anzahl der Minuzien im Template
  UINT8  Data[MINUTIAE_MAX]; // Datenbereich fr die Minuzien

} TEMPLATE ;

//Struktur fr Fingerscanndaten
typedef struct struct_finger 
{

  UINT8    FingerNr;         // Nr. des Fingers
  UINT8    ScannNr;          // Nr. des Scanns des Fingers
  UINT16   Score;            // Trefferqote des Scanns
  TEMPLATE Template;         // Templatedaten des Scanns

} FINGER;

//Struktur fr eine Scannliste
typedef struct struct_finger_list 
{

  TEMPLATE Scanns[FINGER_MAX][SCANN_MAX];

} SCANNLIST;

//Struktur fr eine Liste mit den Trefferqoten
typedef struct struct_match_list 
{

  UINT16 Score[FINGER_MAX][SCANN_MAX];

} MATCHLIST;

//Struktur fr eine Liste mit Fingerdaten fr die Suche des besten Fingers
typedef struct struct_score_list 
{

  FINGER Score[FINGER_MAX];

} FINGERLIST;

//Definition der Funktionen ausserhalb der Objektklassendefinition
void CallFunctions(unsigned char, unsigned char, UINT64 PID);
void ScannBestFinger(unsigned char FingerCount,unsigned char ScannCount, SCANNLIST *scanns );
void MatchBestFinger(unsigned char FingerCount,unsigned char ScannCount, SCANNLIST *scanns, MATCHLIST *match);
void FindBestFinger(unsigned char FingerCount,unsigned char ScannCount, SCANNLIST *scanns, MATCHLIST *match, FINGERLIST *FingerScore);
void SaveBestFinger(unsigned char FingerCount, FINGERLIST *FingerScore, UINT64 PID);
/////////////////////////////////////////////////////////////////////////////
// CDemo2App:
// Siehe Demo2.cpp fr die Implementierung dieser Klasse
//

class CDemo2App : public CWinApp
{
public:
	CDemo2App();

public:
	volatile INT32 m_threadEnd;
	volatile INT32 m_threadError;
	volatile HWND m_hWnd;	// Handle eines Dialoges fr Messages der Com-Thread
  volatile CDialog *m_pDlg;
	volatile enum threadCommand {
		idle, 
		Firmwareupdate,
		BestFinger
	} m_threadCommand;

protected:
	CWinThread *m_thread;
	CString m_msg;

// Main - Funktion fuer Befehlsausfuehrung in Workerthread
public:
	static UINT32 WorkerThread(LPVOID lpParam);
	// This fuer static Call
	static CDemo2App *m_this;
	LRESULT MessageToWindow(WPARAM par1, LPARAM par2);

protected:
	int ThreadFirmwareupdate();
	int ThreadBestFinger();

public:

// berladungen
	// Vom Klassenassistenten generierte berladungen virtueller Funktionen
	//{{AFX_VIRTUAL(CDemo2App)
	public:
	virtual BOOL InitInstance();
	virtual int ExitInstance();
	//}}AFX_VIRTUAL

// Implementierung

	//{{AFX_MSG(CDemo2App)
		// HINWEIS - An dieser Stelle werden Member-Funktionen vom Klassen-Assistenten eingefgt und entfernt.
		//    Innerhalb dieser generierten Quelltextabschnitte NICHTS VERNDERN!
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


/////////////////////////////////////////////////////////////////////////////
extern class CDemo2App theApp;

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ fgt unmittelbar vor der vorhergehenden Zeile zustzliche Deklarationen ein.

#endif // !defined(AFX_DEMO2_H__0CCBEE9A_A05F_4939_A79C_7677AA680A6D__INCLUDED_)
