// DlgBestFinger.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "Demo2.h"
#include "DlgBestFinger.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Dialogfeld CDlgBestFinger 


CDlgBestFinger::CDlgBestFinger(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgBestFinger::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgBestFinger)
	m_fingerCount = 0;
	m_fingerScannCount = 0;
	m_out = _T("");
	m_pid = 0;
	//}}AFX_DATA_INIT
}


void CDlgBestFinger::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgBestFinger)
	DDX_Text(pDX, IDC_FINGER_COUNT, m_fingerCount);
	DDV_MinMaxInt(pDX, m_fingerCount, 2, 10);
	DDX_Text(pDX, IDC_FINGER_SCANN_COUNT, m_fingerScannCount);
	DDV_MinMaxInt(pDX, m_fingerScannCount, 2, 10);
	DDX_Text(pDX, IDC_OUT, m_out);
	DDX_Text(pDX, IDC_PID, m_pid);
	DDV_MinMaxDWord(pDX, m_pid, 1, 4294967295);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgBestFinger, CDialog)
	//{{AFX_MSG_MAP(CDlgBestFinger)
	ON_BN_CLICKED(IDC_EXECUTE, OnExecute)
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_THREAD, OnThread)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten CDlgBestFinger 

BOOL CDlgBestFinger::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Zustzliche Initialisierung hier einfgen
	m_fingerCount = 2;
	m_fingerScannCount = 2;
	// Daten in die Ctrls uebernehmen
	UpdateData(FALSE);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX-Eigenschaftenseiten sollten FALSE zurckgeben
}

/*############################################################################*/
//  FUNKTION:	 OnThread
/** Abfangen der Windowsmessage WM_THREAD.

Autor                 : Bernd Ottmann             @n
erstellt am           : 15.07.2008                @n

@return Gibt immer TRUE zurck.

@b AUFGABE:    

- Abfangen der Windowsmessage WM_THREAD und ausfhren der gegebenen Rckmeldung.

@b KOMMENTARE:

@b NDERUNG:

@b LAUFZEIT :

@b TEST :

*/
/*############################################################################*/

LRESULT CDlgBestFinger::OnThread(WPARAM wParam, LPARAM lParam)
{
	switch(wParam) {
	case MSG_COMMAND_START: // Ausfuehrung eines Kommunikationsbefehls gestartet
		GetDlgItem(IDC_FINGER_COUNT)->EnableWindow(FALSE);
		GetDlgItem(IDC_FINGER_SCANN_COUNT)->EnableWindow(FALSE);
		GetDlgItem(IDC_OUT)->EnableWindow(FALSE);
		break;
		
	case MSG_COMMAND_STOP: // Ausfuehrung eines Kommunikationsbefehls beendet
		GetDlgItem(IDC_FINGER_COUNT)->EnableWindow(TRUE);
		GetDlgItem(IDC_FINGER_SCANN_COUNT)->EnableWindow(TRUE);
		GetDlgItem(IDC_OUT)->EnableWindow(TRUE);
		break;
		
	case MSG_INFORMATION: { // Zeichenfolge in Output uebernehmen (Information)
		
		m_out.Format("%s", (char*)lParam);
		UpdateData(FALSE);
		break;}
		
	default:
		TRACE("CDlgBestFinger::OnThread: Nicht eingetragene Threadmessage.\n");
	}
	
	return TRUE;
}

// Buttonbefehl abarbeiten
void CDlgBestFinger::OnExecute() 
{
	// Wird derzeit noch ein Befehl abgearbeitet?
	if (theApp.m_threadCommand != CDemo2App::idle) {
		
		AfxMessageBox("Es ist noch eine Befehlsausfhrung aktiv.");
		return;
	}
	
	// Daten von Dialog in Memebervariable uebernehmen
	UpdateData(TRUE);
	
	// Befehl an Workerthread der Anwendung weitergeben
	theApp.m_pDlg = this;
	theApp.m_hWnd = GetSafeHwnd();
	theApp.m_threadCommand = CDemo2App::BestFinger;
}


